//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class Filter {
  /// Returns a new [Filter] instance.
  Filter({
    required this.field,
    this.key,
    this.value,
    required this.relation,
  });

  /// Name of the field to use as the first operand in the filter expression.
  String field;

  /// If `field` is `tag`, this field is *required* to specify `key` inside the tags.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? key;

  /// Constant value to use as the second operand in the filter expression.  This value is *required* when the relation operator is a binary operator.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? value;

  /// Operator of a filter expression.
  FilterRelationEnum relation;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Filter &&
          other.field == field &&
          other.key == key &&
          other.value == value &&
          other.relation == relation;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (field.hashCode) +
      (key == null ? 0 : key!.hashCode) +
      (value == null ? 0 : value!.hashCode) +
      (relation.hashCode);

  @override
  String toString() =>
      'Filter[field=$field, key=$key, value=$value, relation=$relation]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'field'] = field;
    if (key != null) {
      _json[r'key'] = key;
    }
    if (value != null) {
      _json[r'value'] = value;
    }
    _json[r'relation'] = relation;
    return _json;
  }

  /// Returns a new [Filter] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static Filter? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "Filter[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "Filter[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return Filter(
        field: mapValueOfType<String>(json, r'field')!,
        key: mapValueOfType<String>(json, r'key'),
        value: mapValueOfType<String>(json, r'value'),
        relation: FilterRelationEnum.fromJson(json[r'relation'])!,
      );
    }
    return null;
  }

  static List<Filter>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <Filter>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = Filter.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, Filter> mapFromJson(dynamic json) {
    final map = <String, Filter>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = Filter.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of Filter-objects as value to a dart map
  static Map<String, List<Filter>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<Filter>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = Filter.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{
    'field',
    'relation',
  };
}

/// Operator of a filter expression.
class FilterRelationEnum {
  /// Instantiate a new enum with the provided [value].
  const FilterRelationEnum._(this.value);

  /// The underlying value of this enum member.
  final String value;

  @override
  String toString() => value;

  String toJson() => value;

  static const greaterThan = FilterRelationEnum._(r'>');
  static const lessThan = FilterRelationEnum._(r'<');
  static const equal = FilterRelationEnum._(r'=');
  static const exclamationEqual = FilterRelationEnum._(r'!=');
  static const exists = FilterRelationEnum._(r'exists');
  static const notExists = FilterRelationEnum._(r'not_exists');
  static const timeElapsedGt = FilterRelationEnum._(r'time_elapsed_gt');
  static const timeElapsedLt = FilterRelationEnum._(r'time_elapsed_lt');

  /// List of all possible values in this [enum][FilterRelationEnum].
  static const values = <FilterRelationEnum>[
    greaterThan,
    lessThan,
    equal,
    exclamationEqual,
    exists,
    notExists,
    timeElapsedGt,
    timeElapsedLt,
  ];

  static FilterRelationEnum? fromJson(dynamic value) =>
      FilterRelationEnumTypeTransformer().decode(value);

  static List<FilterRelationEnum>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <FilterRelationEnum>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = FilterRelationEnum.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }
}

/// Transformation class that can [encode] an instance of [FilterRelationEnum] to String,
/// and [decode] dynamic data back to [FilterRelationEnum].
class FilterRelationEnumTypeTransformer {
  factory FilterRelationEnumTypeTransformer() =>
      _instance ??= const FilterRelationEnumTypeTransformer._();

  const FilterRelationEnumTypeTransformer._();

  String encode(FilterRelationEnum data) => data.value;

  /// Decodes a [dynamic value][data] to a FilterRelationEnum.
  ///
  /// If [allowNull] is true and the [dynamic value][data] cannot be decoded successfully,
  /// then null is returned. However, if [allowNull] is false and the [dynamic value][data]
  /// cannot be decoded successfully, then an [UnimplementedError] is thrown.
  ///
  /// The [allowNull] is very handy when an API changes and a new enum value is added or removed,
  /// and users are still using an old app with the old code.
  FilterRelationEnum? decode(dynamic data, {bool allowNull = true}) {
    if (data != null) {
      switch (data.toString()) {
        case r'>':
          return FilterRelationEnum.greaterThan;
        case r'<':
          return FilterRelationEnum.lessThan;
        case r'=':
          return FilterRelationEnum.equal;
        case r'!=':
          return FilterRelationEnum.exclamationEqual;
        case r'exists':
          return FilterRelationEnum.exists;
        case r'not_exists':
          return FilterRelationEnum.notExists;
        case r'time_elapsed_gt':
          return FilterRelationEnum.timeElapsedGt;
        case r'time_elapsed_lt':
          return FilterRelationEnum.timeElapsedLt;
        default:
          if (!allowNull) {
            throw ArgumentError('Unknown enum value to decode: $data');
          }
      }
    }
    return null;
  }

  /// Singleton [FilterRelationEnumTypeTransformer] instance.
  static FilterRelationEnumTypeTransformer? _instance;
}
