//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class NotificationTarget {
  /// Returns a new [NotificationTarget] instance.
  NotificationTarget({
    this.includedSegments = const [],
    this.excludedSegments = const [],
    this.lastSession,
    this.firstSession,
    this.sessionCount,
    this.sessionTime,
    this.amountSpent,
    this.boughtSku,
    this.tag,
    this.language,
    this.appVersion,
    this.location,
    this.email,
    this.country,
    this.includePlayerIds = const [],
    this.includeExternalUserIds = const [],
    this.includeEmailTokens = const [],
    this.includePhoneNumbers = const [],
    this.includeIosTokens = const [],
    this.includeWpWnsUris = const [],
    this.includeAmazonRegIds = const [],
    this.includeChromeRegIds = const [],
    this.includeChromeWebRegIds = const [],
    this.includeAndroidRegIds = const [],
  });

  /// The segment names you want to target. Users in these segments will receive a notification. This targeting parameter is only compatible with excluded_segments. Example: [\"Active Users\", \"Inactive Users\"]
  List<String> includedSegments;

  /// Segment that will be excluded when sending. Users in these segments will not receive a notification, even if they were included in included_segments. This targeting parameter is only compatible with included_segments. Example: [\"Active Users\", \"Inactive Users\"]
  List<String> excludedSegments;

  /// relation = \">\" or \"<\" hours_ago = number of hours before or after the users last session. Example: \"1.1\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? lastSession;

  /// relation = \">\" or \"<\" hours_ago = number of hours before or after the users first session. Example: \"1.1\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? firstSession;

  /// relation = \">\", \"<\", \"=\" or \"!=\" value = number sessions. Example: \"1\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? sessionCount;

  /// relation = \">\", \"<\", \"=\" or \"!=\" value = Time in seconds the user has been in your app. Example: \"3600\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? sessionTime;

  /// relation = \">\", \"<\", or \"=\" value = Amount in USD a user has spent on IAP (In App Purchases). Example: \"0.99\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? amountSpent;

  /// relation = \">\", \"<\" or \"=\" key = SKU purchased in your app as an IAP (In App Purchases). Example: \"com.domain.100coinpack\" value = value of SKU to compare to. Example: \"0.99\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? boughtSku;

  /// relation = \">\", \"<\", \"=\", \"!=\", \"exists\", \"not_exists\", \"time_elapsed_gt\" (paid plan only) or \"time_elapsed_lt\" (paid plan only) See Time Operators key = Tag key to compare. value = Tag value to compare. Not required for \"exists\" or \"not_exists\". Example: See Formatting Filters
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? tag;

  /// relation = \"=\" or \"!=\" value = 2 character language code. Example: \"en\". For a list of all language codes see Language & Localization.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? language;

  /// relation = \">\", \"<\", \"=\" or \"!=\" value = app version. Example: \"1.0.0\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? appVersion;

  /// radius = in meters lat = latitude long = longitude
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? location;

  /// value = email address Only for sending Push Notifications Use this for targeting push subscribers associated with an email set with all SDK setEmail methods To send emails to specific email addresses use include_email_tokens parameter
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? email;

  /// relation = \"=\" value = 2-digit Country code Example: \"field\": \"country\", \"relation\": \"=\", \"value\", \"US\"
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? country;

  /// Specific playerids to send your notification to. _Does not require API Auth Key. Do not combine with other targeting parameters. Not compatible with any other targeting parameters. Example: [\"1dd608f2-c6a1-11e3-851d-000c2940e62c\"] Limit of 2,000 entries per REST API call
  List<String> includePlayerIds;

  /// Target specific devices by custom user IDs assigned via API. Not compatible with any other targeting parameters Example: [\"custom-id-assigned-by-api\"] REQUIRED: REST API Key Authentication Limit of 2,000 entries per REST API call. Note: If targeting push, email, or sms subscribers with same ids, use with channel_for_external_user_ids to indicate you are sending a push or email or sms.
  List<String> includeExternalUserIds;

  /// Recommended for Sending Emails - Target specific email addresses. If an email does not correspond to an existing user, a new user will be created. Example: nick@catfac.ts Limit of 2,000 entries per REST API call
  List<String> includeEmailTokens;

  /// Recommended for Sending SMS - Target specific phone numbers. The phone number should be in the E.164 format. Phone number should be an existing subscriber on OneSignal. Refer our docs to learn how to add phone numbers to OneSignal. Example phone number: +1999999999 Limit of 2,000 entries per REST API call
  List<String> includePhoneNumbers;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using iOS device tokens. Warning: Only works with Production tokens. All non-alphanumeric characters must be removed from each token. If a token does not correspond to an existing user, a new user will be created. Example: ce777617da7f548fe7a9ab6febb56cf39fba6d38203... Limit of 2,000 entries per REST API call
  List<String> includeIosTokens;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Windows URIs. If a token does not correspond to an existing user, a new user will be created. Example: http://s.notify.live.net/u/1/bn1/HmQAAACPaLDr-... Limit of 2,000 entries per REST API call
  List<String> includeWpWnsUris;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Amazon ADM registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: amzn1.adm-registration.v1.XpvSSUk0Rc3hTVVV... Limit of 2,000 entries per REST API call
  List<String> includeAmazonRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Chrome App registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeChromeRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Chrome Web Push registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeChromeWebRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Android device registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeAndroidRegIds;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is NotificationTarget &&
          other.includedSegments == includedSegments &&
          other.excludedSegments == excludedSegments &&
          other.lastSession == lastSession &&
          other.firstSession == firstSession &&
          other.sessionCount == sessionCount &&
          other.sessionTime == sessionTime &&
          other.amountSpent == amountSpent &&
          other.boughtSku == boughtSku &&
          other.tag == tag &&
          other.language == language &&
          other.appVersion == appVersion &&
          other.location == location &&
          other.email == email &&
          other.country == country &&
          other.includePlayerIds == includePlayerIds &&
          other.includeExternalUserIds == includeExternalUserIds &&
          other.includeEmailTokens == includeEmailTokens &&
          other.includePhoneNumbers == includePhoneNumbers &&
          other.includeIosTokens == includeIosTokens &&
          other.includeWpWnsUris == includeWpWnsUris &&
          other.includeAmazonRegIds == includeAmazonRegIds &&
          other.includeChromeRegIds == includeChromeRegIds &&
          other.includeChromeWebRegIds == includeChromeWebRegIds &&
          other.includeAndroidRegIds == includeAndroidRegIds;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (includedSegments.hashCode) +
      (excludedSegments.hashCode) +
      (lastSession == null ? 0 : lastSession!.hashCode) +
      (firstSession == null ? 0 : firstSession!.hashCode) +
      (sessionCount == null ? 0 : sessionCount!.hashCode) +
      (sessionTime == null ? 0 : sessionTime!.hashCode) +
      (amountSpent == null ? 0 : amountSpent!.hashCode) +
      (boughtSku == null ? 0 : boughtSku!.hashCode) +
      (tag == null ? 0 : tag!.hashCode) +
      (language == null ? 0 : language!.hashCode) +
      (appVersion == null ? 0 : appVersion!.hashCode) +
      (location == null ? 0 : location!.hashCode) +
      (email == null ? 0 : email!.hashCode) +
      (country == null ? 0 : country!.hashCode) +
      (includePlayerIds.hashCode) +
      (includeExternalUserIds.hashCode) +
      (includeEmailTokens.hashCode) +
      (includePhoneNumbers.hashCode) +
      (includeIosTokens.hashCode) +
      (includeWpWnsUris.hashCode) +
      (includeAmazonRegIds.hashCode) +
      (includeChromeRegIds.hashCode) +
      (includeChromeWebRegIds.hashCode) +
      (includeAndroidRegIds.hashCode);

  @override
  String toString() =>
      'NotificationTarget[includedSegments=$includedSegments, excludedSegments=$excludedSegments, lastSession=$lastSession, firstSession=$firstSession, sessionCount=$sessionCount, sessionTime=$sessionTime, amountSpent=$amountSpent, boughtSku=$boughtSku, tag=$tag, language=$language, appVersion=$appVersion, location=$location, email=$email, country=$country, includePlayerIds=$includePlayerIds, includeExternalUserIds=$includeExternalUserIds, includeEmailTokens=$includeEmailTokens, includePhoneNumbers=$includePhoneNumbers, includeIosTokens=$includeIosTokens, includeWpWnsUris=$includeWpWnsUris, includeAmazonRegIds=$includeAmazonRegIds, includeChromeRegIds=$includeChromeRegIds, includeChromeWebRegIds=$includeChromeWebRegIds, includeAndroidRegIds=$includeAndroidRegIds]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'included_segments'] = includedSegments;
    _json[r'excluded_segments'] = excludedSegments;
    if (lastSession != null) {
      _json[r'last_session'] = lastSession;
    }
    if (firstSession != null) {
      _json[r'first_session'] = firstSession;
    }
    if (sessionCount != null) {
      _json[r'session_count'] = sessionCount;
    }
    if (sessionTime != null) {
      _json[r'session_time'] = sessionTime;
    }
    if (amountSpent != null) {
      _json[r'amount_spent'] = amountSpent;
    }
    if (boughtSku != null) {
      _json[r'bought_sku'] = boughtSku;
    }
    if (tag != null) {
      _json[r'tag'] = tag;
    }
    if (language != null) {
      _json[r'language'] = language;
    }
    if (appVersion != null) {
      _json[r'app_version'] = appVersion;
    }
    if (location != null) {
      _json[r'location'] = location;
    }
    if (email != null) {
      _json[r'email'] = email;
    }
    if (country != null) {
      _json[r'country'] = country;
    }
    _json[r'include_player_ids'] = includePlayerIds;
    _json[r'include_external_user_ids'] = includeExternalUserIds;
    _json[r'include_email_tokens'] = includeEmailTokens;
    _json[r'include_phone_numbers'] = includePhoneNumbers;
    _json[r'include_ios_tokens'] = includeIosTokens;
    _json[r'include_wp_wns_uris'] = includeWpWnsUris;
    _json[r'include_amazon_reg_ids'] = includeAmazonRegIds;
    _json[r'include_chrome_reg_ids'] = includeChromeRegIds;
    _json[r'include_chrome_web_reg_ids'] = includeChromeWebRegIds;
    _json[r'include_android_reg_ids'] = includeAndroidRegIds;
    return _json;
  }

  /// Returns a new [NotificationTarget] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static NotificationTarget? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "NotificationTarget[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "NotificationTarget[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return NotificationTarget(
        includedSegments: json[r'included_segments'] is List
            ? (json[r'included_segments'] as List).cast<String>()
            : const [],
        excludedSegments: json[r'excluded_segments'] is List
            ? (json[r'excluded_segments'] as List).cast<String>()
            : const [],
        lastSession: mapValueOfType<String>(json, r'last_session'),
        firstSession: mapValueOfType<String>(json, r'first_session'),
        sessionCount: mapValueOfType<String>(json, r'session_count'),
        sessionTime: mapValueOfType<String>(json, r'session_time'),
        amountSpent: mapValueOfType<String>(json, r'amount_spent'),
        boughtSku: mapValueOfType<String>(json, r'bought_sku'),
        tag: mapValueOfType<String>(json, r'tag'),
        language: mapValueOfType<String>(json, r'language'),
        appVersion: mapValueOfType<String>(json, r'app_version'),
        location: mapValueOfType<String>(json, r'location'),
        email: mapValueOfType<String>(json, r'email'),
        country: mapValueOfType<String>(json, r'country'),
        includePlayerIds: json[r'include_player_ids'] is List
            ? (json[r'include_player_ids'] as List).cast<String>()
            : const [],
        includeExternalUserIds: json[r'include_external_user_ids'] is List
            ? (json[r'include_external_user_ids'] as List).cast<String>()
            : const [],
        includeEmailTokens: json[r'include_email_tokens'] is List
            ? (json[r'include_email_tokens'] as List).cast<String>()
            : const [],
        includePhoneNumbers: json[r'include_phone_numbers'] is List
            ? (json[r'include_phone_numbers'] as List).cast<String>()
            : const [],
        includeIosTokens: json[r'include_ios_tokens'] is List
            ? (json[r'include_ios_tokens'] as List).cast<String>()
            : const [],
        includeWpWnsUris: json[r'include_wp_wns_uris'] is List
            ? (json[r'include_wp_wns_uris'] as List).cast<String>()
            : const [],
        includeAmazonRegIds: json[r'include_amazon_reg_ids'] is List
            ? (json[r'include_amazon_reg_ids'] as List).cast<String>()
            : const [],
        includeChromeRegIds: json[r'include_chrome_reg_ids'] is List
            ? (json[r'include_chrome_reg_ids'] as List).cast<String>()
            : const [],
        includeChromeWebRegIds: json[r'include_chrome_web_reg_ids'] is List
            ? (json[r'include_chrome_web_reg_ids'] as List).cast<String>()
            : const [],
        includeAndroidRegIds: json[r'include_android_reg_ids'] is List
            ? (json[r'include_android_reg_ids'] as List).cast<String>()
            : const [],
      );
    }
    return null;
  }

  static List<NotificationTarget>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <NotificationTarget>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = NotificationTarget.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, NotificationTarget> mapFromJson(dynamic json) {
    final map = <String, NotificationTarget>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = NotificationTarget.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of NotificationTarget-objects as value to a dart map
  static Map<String, List<NotificationTarget>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<NotificationTarget>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = NotificationTarget.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{};
}
