//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class SegmentNotificationTarget {
  /// Returns a new [SegmentNotificationTarget] instance.
  SegmentNotificationTarget({
    this.includedSegments = const [],
    this.excludedSegments = const [],
  });

  /// The segment names you want to target. Users in these segments will receive a notification. This targeting parameter is only compatible with excluded_segments. Example: [\"Active Users\", \"Inactive Users\"]
  List<String> includedSegments;

  /// Segment that will be excluded when sending. Users in these segments will not receive a notification, even if they were included in included_segments. This targeting parameter is only compatible with included_segments. Example: [\"Active Users\", \"Inactive Users\"]
  List<String> excludedSegments;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is SegmentNotificationTarget &&
          other.includedSegments == includedSegments &&
          other.excludedSegments == excludedSegments;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (includedSegments.hashCode) + (excludedSegments.hashCode);

  @override
  String toString() =>
      'SegmentNotificationTarget[includedSegments=$includedSegments, excludedSegments=$excludedSegments]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'included_segments'] = includedSegments;
    _json[r'excluded_segments'] = excludedSegments;
    return _json;
  }

  /// Returns a new [SegmentNotificationTarget] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static SegmentNotificationTarget? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "SegmentNotificationTarget[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "SegmentNotificationTarget[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return SegmentNotificationTarget(
        includedSegments: json[r'included_segments'] is List
            ? (json[r'included_segments'] as List).cast<String>()
            : const [],
        excludedSegments: json[r'excluded_segments'] is List
            ? (json[r'excluded_segments'] as List).cast<String>()
            : const [],
      );
    }
    return null;
  }

  static List<SegmentNotificationTarget>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <SegmentNotificationTarget>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = SegmentNotificationTarget.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, SegmentNotificationTarget> mapFromJson(dynamic json) {
    final map = <String, SegmentNotificationTarget>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = SegmentNotificationTarget.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of SegmentNotificationTarget-objects as value to a dart map
  static Map<String, List<SegmentNotificationTarget>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<SegmentNotificationTarget>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = SegmentNotificationTarget.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{};
}
